/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef CIMAGEVIEWER_H
#define CIMAGEVIEWER_H


#include "cviewer.h"


class CViewPortWatcher;



class CGraphicsView:public QGraphicsView
{
    Q_OBJECT

    friend class CImageViewer;

    CViewPortWatcher *ViewPortWatcher;

protected:
    void wheelEvent(QWheelEvent *e);
    void resizeEvent(QResizeEvent * event );

public:
    CGraphicsView(QWidget * parent = 0);

public slots:
    void setScale(qreal scl);
};



class CImageViewer:public CViewer
{
   Q_OBJECT
   Q_PROPERTY(QImage image READ image WRITE setImage NOTIFY imageChanged)

 public:
   CImageViewer(_schemeData* schemed,QWidget *parent=0);
   virtual ~CImageViewer();
   void setImage(const QImage &img);
   QImage image() const {return _image;}
   QGraphicsScene* scene() const {return imageScene;}
   CViewPortWatcher *viewPortWatcher() const {return imageView->ViewPortWatcher;}

 private slots:
   void schemeBtnPress(){emit makeScheme(schemeData);}

 signals:
   void imageChanged(QImage);
   void makeScheme(_schemeData*);


 private:
   QImage _image;
   _schemeData    *schemeData;
   CGraphicsView  *imageView;
   QGraphicsScene *imageScene;
};

#endif // CIMAGEVIEWER_H
